#include <dirent.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>

const char* typPliku(unsigned typ) {
    switch(typ) {
      case DT_UNKNOWN: 	return "Nieznany typ, nie wszystkie systemy rozróżniaja typy, czesto jest zwracana ta wartosc";
      case DT_REG: 	return "Regularny plik";
      case DT_DIR:	return "Katalog";
      case DT_FIFO:	return "Potok nazwany";
      case DT_SOCK:	return "Lokalne gniazdo";
      case DT_CHR:	return "Urządzenie znakowe 'A character device'";
      case DT_BLK:	return "Urzadzenie blokowe 'A block device'";
      case DT_LNK:	return "Dowiazanie symboliczne";
    };
}

void wyswietlDwojako(const char * nazwa_sciezki) {
  int kontrolny_INT;
  DIR *sciezka1, *sciezka2;
  struct dirent element;
  struct dirent *element_wskaznik, *element_wskaznik2;

  if( (sciezka1 = opendir(nazwa_sciezki)) && (sciezka2 = opendir(nazwa_sciezki)) ) {
    for (kontrolny_INT = readdir_r(sciezka1, &element, &element_wskaznik), element_wskaznik2=readdir(sciezka2); element_wskaznik != NULL && kontrolny_INT == 0 && sciezka2!=NULL; kontrolny_INT = readdir_r(sciezka1, &element, &element_wskaznik), element_wskaznik2=readdir(sciezka2)) {
      printf("readdir_r zwraca: normalnie = '%s' wskaznikowo = '%s'\n", element.d_name, element_wskaznik->d_name);
      printf("readdir zwraca wskaznikowo = '%s'\n", element_wskaznik2->d_name);
      printf("\tinne cechy pliku (nie na wszystkich systemach wszystkie będą działać):");
      printf("\tnumer seryjny pliku = %lu\n", element_wskaznik2->d_ino);
      printf("\ttyp pliku nr %d, tekstowo: '%s'\n", element_wskaznik2->d_type, typPliku(element_wskaznik2->d_type));
      printf("\toffset pliku = %ld", element_wskaznik2->d_off);
      printf("\trozmiar struktury = %d\n", element_wskaznik2->d_reclen);
    }
    if (kontrolny_INT)
      perror("blad uzycia funkcji readdir_r()");
    closedir(sciezka1);
    closedir(sciezka2);
  }
  else
    perror("blad przy otwarciu, chyba zla nazwa sciezki\n");
}

main() {
  wyswietlDwojako(".");
  printf("\nmaksymalna dlugosc nazwy w d_name to %d\n", NAME_MAX);
}	//    gcc     listowanie4.c -o listowanie4 && ./listowanie4
